/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.records.TCoreVargrpRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreVargrp extends TableImpl<TCoreVargrpRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_vargrp</code>
     */
    public static final TCoreVargrp T_CORE_VARGRP = new TCoreVargrp();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreVargrpRecord> getRecordType() {
        return TCoreVargrpRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_vargrp.lastchange</code>.
     */
    public final TableField<TCoreVargrpRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_vargrp.pk</code>.
     */
    public final TableField<TCoreVargrpRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_vargrp.fk_key_element</code>. Foreign
     * key to t_core_element_hierarchy
     */
    public final TableField<TCoreVargrpRecord, Integer> FK_KEY_ELEMENT = createField(DSL.name("fk_key_element"), SQLDataType.INTEGER.nullable(false), this, "Foreign key to t_core_element_hierarchy");

    private TCoreVargrp(Name alias, Table<TCoreVargrpRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreVargrp(Name alias, Table<TCoreVargrpRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_vargrp</code> table reference
     */
    public TCoreVargrp(String alias) {
        this(DSL.name(alias), T_CORE_VARGRP);
    }

    /**
     * Create an aliased <code>common_dd.t_core_vargrp</code> table reference
     */
    public TCoreVargrp(Name alias) {
        this(alias, T_CORE_VARGRP);
    }

    /**
     * Create a <code>common_dd.t_core_vargrp</code> table reference
     */
    public TCoreVargrp() {
        this(DSL.name("t_core_vargrp"), null);
    }

    public <O extends Record> TCoreVargrp(Table<O> path, ForeignKey<O, TCoreVargrpRecord> childPath, InverseForeignKey<O, TCoreVargrpRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_VARGRP);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreVargrpPath extends TCoreVargrp implements Path<TCoreVargrpRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreVargrpPath(Table<O> path, ForeignKey<O, TCoreVargrpRecord> childPath, InverseForeignKey<O, TCoreVargrpRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreVargrpPath(Name alias, Table<TCoreVargrpRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreVargrpPath as(String alias) {
            return new TCoreVargrpPath(DSL.name(alias), this);
        }

        @Override
        public TCoreVargrpPath as(Name alias) {
            return new TCoreVargrpPath(alias, this);
        }

        @Override
        public TCoreVargrpPath as(Table<?> alias) {
            return new TCoreVargrpPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreVargrpRecord, Integer> getIdentity() {
        return (Identity<TCoreVargrpRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreVargrpRecord> getPrimaryKey() {
        return Keys.PK_CORE_VARGRP;
    }

    @Override
    public List<ForeignKey<TCoreVargrpRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_VARGRP__FK_CORE_VARGRP_HIERARCHY);
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table.
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, Keys.T_CORE_VARGRP__FK_CORE_VARGRP_HIERARCHY, null);

        return _tCoreElementHierarchy;
    }

    @Override
    public TCoreVargrp as(String alias) {
        return new TCoreVargrp(DSL.name(alias), this);
    }

    @Override
    public TCoreVargrp as(Name alias) {
        return new TCoreVargrp(alias, this);
    }

    @Override
    public TCoreVargrp as(Table<?> alias) {
        return new TCoreVargrp(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreVargrp rename(String name) {
        return new TCoreVargrp(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreVargrp rename(Name name) {
        return new TCoreVargrp(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreVargrp rename(Table<?> name) {
        return new TCoreVargrp(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVargrp where(Condition condition) {
        return new TCoreVargrp(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVargrp where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVargrp where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVargrp where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreVargrp where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreVargrp where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreVargrp where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreVargrp where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVargrp whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVargrp whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
